; *********************************************************************
; **************		DCF clock		***************
; *********************************************************************
;
; ****************** Navrzeno pro fosc = 3.2768 MHz *******************
;
		LIST		p=16F84A
		INCLUDE		P16F84A.inc
; *************
; *** Fuses ***
; *************
	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_OFF & _XT_OSC
	__IDLOCS H'0033'
; *************************
; *** Adresy a promenne ***
; *************************
dcf_in		equ	4
state		equ	H'0C'
dcf_bit		equ	0
dcf_last	equ	1
control_ok	equ	2
signal_error	equ	3
parity		equ	4
try_parity	equ	5
dec_point	equ	6
key_in		equ	7
counter		equ	H'0D'
pointer		equ	H'0E'
what_display	equ	H'0F'
time_fl		equ	0
a1_on		equ	1
a2_on		equ	2
a2_off		equ	3
a2_days		equ	4
date		equ	5
dcf_time_lo	equ	H'10'
dcf_time_hi	equ	H'11'
over		equ	3
time_prescaler	equ	H'12'
pre_par_count	equ	H'13'
temp		equ	H'14'
sec		equ	H'15'
min		equ	H'16'
hour		equ	H'17'
day		equ	H'18'
day_name	equ	H'19'
month		equ	H'1A'
year		equ	H'1B'
min_dcf		equ	H'1C'
hour_dcf	equ	H'1D'
day_dcf		equ	H'1E'
day_name_dcf	equ	H'1F'
month_dcf	equ	H'20'
year_dcf	equ	H'21'
min_last	equ	H'22'
hour_last	equ	H'23'
day_last	equ	H'24'
day_name_last	equ	H'25'
month_last	equ	H'26'
year_last	equ	H'27'
a1_min_on	equ	H'28'
a1_hour_on	equ	H'29'
a2_min_on	equ	H'2A'
a2_hour_on	equ	H'2B'
a2_days_on	equ	H'2C'
a2_min_off	equ	H'2D'
a2_hour_off	equ	H'2E'
state2		equ	H'2F'
a1_validity	equ	4
a1_switch_on	equ	5
a2_validity	equ	6
a2_switch_on	equ	7

; *****************
; *** Konstanty ***
; *****************
time_50ms	equ	H'28'
time_150ms	equ	H'78'
time_250ms	equ	H'C8'
; ****************
; *** Adresa 0 ***
; ****************
reset		clrf	PORTB
		movlw	H'0C'
		movwf	FSR
		goto	start
; ************************************
; *** Adresa 4 - preruseni od TMR0 ***
; ************************************
interrupt	btfss	INTCON,T0IF
		retfie
		bcf	INTCON,T0IF
		btfss	PORTA,dcf_in	; testuje vstup dcf_in (PORTA, bit 4)
		goto	dcf_lo
; *******************************************************
; *** dcf_in je hi, nejdrive otestuje zda jiz hi byl: ***
; *** byl - pripocita 1 k dcf_time_lo, pokud pretece, ***
; ***	    skoci na dcf_error			      ***
; *** nebyl - skoci na dcf_change_lo		      ***
; *******************************************************
dcf_hi		btfss	state,dcf_last
		goto	dcf_change_lo
		incfsz	dcf_time_lo,f
		goto	time
		goto	dcf_error
; ********************************************************
; *** dcf_in je lo, nejdrive otestuje, zda jiz lo byl: ***
; *** byl - pricte k dcf_time_lo a dcf_time_low	       ***
; ***	    (druhy rad - pokud pretece prvni rad) 1    ***
; ***	    a pokud je u dcf_time_low bit 3 hi,	       ***
; ***	    nasleduje dcf_error, jinak skoci na time   ***
; *** nebyl - skoci na dcf_change_hi		       ***
; ********************************************************
dcf_lo		btfsc	state,dcf_last
		goto	dcf_change_hi
		incfsz	dcf_time_lo,f
		goto	time
		incf	dcf_time_hi,f
		btfss	dcf_time_hi,over
		goto	time
; ************************************************************
; *** Doslo k prekroceni maximalnich casu na vstupu dcf_in ***
; *** Proto se nastavi signal_error a vynuluje control_ok  ***
; ************************************************************
dcf_error	bsf	state,signal_error
		bcf	state,control_ok
		goto	time
; ************************************************************
; *** Doslo ke zmene na dcf_in z lo na hi, proto se zjisti ***
; *** delka predesleho lo useku				   ***
; *** Pokud byl tento dostatecne dlouhy (dcf_time_hi > 5), ***
; *** probehne dalsi zpracovani dcf informace		   ***
; ************************************************************
dcf_change_lo	bsf	state,dcf_last
		clrf	dcf_time_lo
		movlw	H'05'
		subwf	dcf_time_hi,w
		btfss	STATUS,c
		goto	time
; ************************************************************
; *** Po zjisteni dostatecne delky lo useku se zkontroluje ***
; *** hodnota registru counter (ma byt 59 dec), dale zda   ***
; *** nedoslo k chybe dcf signalu, nastaveni paritniho	   ***
; *** bitu a parita pro datum				   ***
; *** Pokud je vse v poradku pokracuje srovnavanim stare   ***
; *** a nove dcf informace (viz nize), jinak skoci na time ***
; ************************************************************
		bsf	state,control_ok
		movlw	H'3B'
		subwf	counter,f
		btfss	STATUS,z
		bcf	state,control_ok
		clrf	counter
		btfsc	state,signal_error
		bcf	state,control_ok
		bcf	state,signal_error
		btfss	state,parity
		bcf	state,control_ok
		bsf	state,parity
		btfsc	pre_par_count,0
		bcf	state,control_ok
		bcf	pre_par_count,0
		bcf	state,try_parity
		btfss	state,control_ok
		goto	time
; *************************************************************
; *** Pricte 1 minutu ke stare dcf informaci - pro srovnani ***
; *** stare a nove dcf informace			    ***
; *************************************************************
control_dcf	incf	min_last,f
		movf	min_last,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	STATUS,z
		goto	compare_dcf
		movf	min_last,w
		andlw	H'F0'
		addlw	H'10'
		movwf	min_last
		xorlw	H'60'
		btfss	STATUS,z
		goto	compare_dcf
		clrf	min_last
		incf	hour_last,f
		movf	hour_last,w
		xorlw	H'24'
		btfsc	STATUS,z
		goto	next_day
		movf	hour_last,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	STATUS,z
		goto	compare_dcf
		movf	hour_last,w
		andlw	H'F0'
		addlw	H'10'
		movwf	hour_last
		goto	compare_dcf
next_day	clrf	hour_last
		incf	day_name_last,f
		movf	day_name_last,w
		xorlw	H'08'
		movlw	H'01'
		btfsc	STATUS,z
		movwf	day_name_last
		incf	day_last,f
		movf	day_last,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	STATUS,z
		goto	correct_date
		movf	day_last,w
		andlw	H'F0'
		addlw	H'10'
		movwf	day_last
correct_date	movf	month_last,w
		bsf	PCLATH,0
		bsf	PCLATH,1
		call	table_of_days
		clrf	PCLATH
		xorwf	day_last,w
		btfss	STATUS,z
		goto	compare_dcf
		movlw	H'01'
		movwf	day_last
		incf	month_last,f
		movf	month_last,w
		xorlw	H'13'
		btfsc	STATUS,z
		goto	next_year
		movf	month_last,w
		xorlw	H'0A'
		movlw	H'10'
		btfsc	STATUS,z
		movwf	month_last
		goto	compare_dcf
next_year	movlw	H'01'
		movwf	month_last
		incf	year_last,f
		movf	year_last,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	STATUS,z
		goto	compare_dcf
		movf	year_last,w
		andlw	H'F0'
		addlw	H'10'
		movwf	year_last
		xorlw	H'A0'
		btfsc	STATUS,z
		clrf	year_last
; ************************************************************
; *** Srovna stary udaj (s prictenou minutou) a novy udaj  ***
; *** a pokud souhlasi, necha nastaveny bit control_ok	   ***
; *** a provede nastaveni casu, reset sekundy a navrat	   ***
; *** Pokud nesouhlasi, pokracuje v normalnim chodu	   ***
; ************************************************************
compare_dcf	movf	min_dcf,w
		xorwf	min_last,f
		btfss	STATUS,z
		bcf	state,control_ok
		movwf	min_last
		movf	hour_dcf,w
		xorwf	hour_last,f
		btfss	STATUS,z
		bcf	state,control_ok
		movwf	hour_last
		movf	day_name_dcf,w
		xorwf	day_name_last,f
		btfss	STATUS,z
		bcf	state,control_ok
		movwf	day_name_last
		movf	day_dcf,w
		xorwf	day_last,f
		btfss	STATUS,z
		bcf	state,control_ok
		movwf	day_last
		movf	month_dcf,w
		xorwf	month_last,f
		btfss	STATUS,z
		bcf	state,control_ok
		movwf	month_last
		movf	year_dcf,w
		xorwf	year_last,f
		btfss	STATUS,z
		bcf	state,control_ok
		movwf	year_last
		btfss	state,control_ok
		goto	time
		clrf	TMR0
		clrf	time_prescaler
		clrf	pre_par_count
		clrf	sec
		movf	min_dcf,w
		movwf	min
		movf	hour_dcf,w
		movwf	hour
		movf	day_name_dcf,w
		movwf	day_name
		movf	day_dcf,w
		movwf	day
		movf	month_dcf,w
		movwf	month
		movf	year_dcf,w
		movwf	year
		goto	test_of_alms
; *******************************************************************
; *** Doslo ke zmene na vstupu dcf_in z hi na lo, proto rozkoduje ***
; *** delku dcf impulsu						  ***
; *** Pri delce vetsi nez time_250 ms a mensi nez time_50ms skoci ***
; *** na dcf_error						  ***
; *******************************************************************
dcf_change_hi	bcf	state,dcf_last
		clrf	dcf_time_hi
		movlw	time_50ms
		subwf	dcf_time_lo,w
		btfss	STATUS,c
		goto	dcf_error
		movlw	time_250ms
		subwf	dcf_time_lo,w
		btfsc	STATUS,c
		goto	dcf_error
		bcf	state,dcf_bit
		movlw	time_150ms
		subwf	dcf_time_lo,w
		btfsc	STATUS,c
		bsf	state,dcf_bit
		clrf	dcf_time_lo
; ***********************************************************************
; *** Zapisovani rozkodovaneho dcf_bit do registru casu a bitu parity ***
; ***********************************************************************
		movlw	H'3B'
		subwf	counter,w
		btfsc	STATUS,c
		goto	dcf_error
		movlw	H'15'
		subwf	counter,w
		btfss	STATUS,c
		goto	counter_only
		bsf	PCLATH,0
		bsf	PCLATH,1
		call	table_dcf_code
		clrf	PCLATH
		movwf	temp
		btfsc	temp,3
		goto	parity_test
		andlw	H'0F'
		addlw	H'1C'		; offset pro rozkodovani dcf kodu
		movwf	FSR
		swapf	temp,w
		andlw	H'0F'
		btfss	state,dcf_bit
		goto	reset_dcf_bit
		addwf	PCL,f
		bsf	INDF,0
		goto	control_parity
		bsf	INDF,1
		goto	control_parity
		bsf	INDF,2
		goto	control_parity
		bsf	INDF,3
		goto	control_parity
		bsf	INDF,4
		goto	control_parity
		bsf	INDF,5
		goto	control_parity
		bsf	INDF,6
		goto	control_parity
		bsf	INDF,7
		goto	control_parity
reset_dcf_bit	addwf	PCL,f
		bcf	INDF,0
		goto	control_parity
		bcf	INDF,1
		goto	control_parity
		bcf	INDF,2
		goto	control_parity
		bcf	INDF,3
		goto	control_parity
		bcf	INDF,4
		goto	control_parity
		bcf	INDF,5
		goto	control_parity
		bcf	INDF,6
		goto	control_parity
		bcf	INDF,7				
control_parity	btfss	state,try_parity
		goto	end_of_test
		bcf	state,try_parity
		btfsc	pre_par_count,0
		bcf	state,parity
		bcf	pre_par_count,0
		goto	end_of_test
parity_test	bsf	state,try_parity
end_of_test	btfsc	state,dcf_bit
		incf	pre_par_count,f
		bcf	pre_par_count,1
counter_only	incf	counter,f
; *********************************************************
; *** Zde se pocitaji preruseni a pri kazdem osmistem   ***
; *** se pricte 1 sekunda k casu v registrech a zobrazi ***
; *** se casova informace				***
; *********************************************************
time		incfsz	time_prescaler,f
		goto	continue
		movlw	H'10'
		addwf	pre_par_count,f
		goto	test_of_keys
continue	movlw	H'30'
		subwf	pre_par_count,w
		btfss	STATUS,c
		goto	test_of_keys
		movlw	H'20'
		subwf	time_prescaler,w
		btfss	STATUS,z
		goto	test_of_keys
		clrf	time_prescaler
		movlw	H'01'
		andwf	pre_par_count,f
; *****************************************
; *** Pricte sekundu a ohlida preteceni ***
; *** jednotlivych registru casu	***
; *****************************************
plus_second	incf	sec,f
		movf	sec,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	STATUS,z
		goto	test_of_alms
		movf	sec,w
		andlw	H'F0'
		addlw	H'10'
		movwf	sec
		xorlw	H'60'
		btfss	STATUS,z
		goto	test_of_alms
		clrf	sec
		incf	min,f
		movf	min,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	STATUS,z
		goto	test_of_alms
		movf	min,w
		andlw	H'F0'
		addlw	H'10'
		movwf	min
		xorlw	H'60'
		btfss	STATUS,z
		goto	test_of_alms
		clrf	min
		incf	hour,f
		movf	hour,w
		xorlw	H'24'
		btfsc	STATUS,z
		goto	new_day
		movf	hour,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	STATUS,z
		goto	test_of_alms
		movf	hour,w
		andlw	H'F0'
		addlw	H'10'
		movwf	hour
		goto	test_of_alms
new_day		clrf	hour
		incf	day_name,f
		movf	day_name,w
		xorlw	H'08'
		movlw	H'01'
		btfsc	STATUS,z
		movwf	day_name
		incf	day,f
		movf	day,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	STATUS,z
		goto	correction
		movf	day,w
		andlw	H'F0'
		addlw	H'10'
		movwf	day
correction	movf	month,w
		btfsc	month,4
		sublw	H'15'
		bsf	PCLATH,0
		bsf	PCLATH,1
		call	table_of_days
		clrf	PCLATH
		xorwf	day,w
		btfss	STATUS,z
		goto	test_of_alms
		movlw	H'01'
		movwf	day
		incf	month,f
		movf	month,w
		xorlw	H'13'
		btfsc	STATUS,z
		goto	new_year
		movf	month,w
		xorlw	H'0A'
		movlw	H'10'
		btfsc	STATUS,z
		movwf	month
		goto	test_of_alms
new_year	movlw	H'01'
		movwf	month
		incf	year,f
		movf	year,w
		andlw	H'0F'
		xorlw	H'0A'
		btfss	STATUS,z
		goto	test_of_alms
		movf	year,w
		andlw	H'F0'
		addlw	H'10'
		movwf	year
		xorlw	H'A0'
		btfsc	STATUS,z
		clrf	year
; ***********************************************************
; *** Otestuje casy alarmu a dle nich nastavi jejich stav ***
; ***********************************************************
test_of_alms	movf	a1_min_on,w
		subwf	min,w
		btfss	STATUS,z
		goto	alarm_2_on
		movf	a1_hour_on,w
		subwf	hour,w
		btfss	STATUS,z
		goto	alarm_1_off
		clrw
		xorwf	sec,w
		btfss	STATUS,z
		goto	alarm_2_on
		btfsc	state2,a1_validity
		bsf	state2,a1_switch_on
		goto	alarm_2_on
alarm_1_off	bcf	state2,a1_switch_on
alarm_2_on	movf	a2_hour_on,w
		subwf	hour,w
		btfss	STATUS,z
		goto	alarm_2_off
		movf	a2_min_on,w
		subwf	min,w
		btfss	STATUS,z
		goto	alarm_2_off
		clrw
		xorwf	sec,w
		btfss	STATUS,z
		goto	alarm_2_off
		swapf	a2_days_on,w
		andlw	H'0F'
		subwf	day_name,w
		btfss	STATUS,c
		goto	alarm_2_off
		incf	a2_days_on,w
		andlw	H'0F'
		subwf	day_name,w
		btfsc	STATUS,c
		goto	alarm_2_off
		btfsc	state2,a2_validity
		bsf	state2,a2_switch_on
alarm_2_off	movf	a2_hour_off,w
		subwf	hour,w
		btfss	STATUS,z
		goto	test_of_keys
		movf	a2_min_off,w
		subwf	min,w
		btfsc	STATUS,z
		bcf	state2,a2_switch_on
; *************************************************************
; *** Zjisti stav tlacitek a zobrazi odpovidajici informaci ***
; *** na display hodin					    ***
; *************************************************************
test_of_keys	movlw	H'06'
		subwf	pointer,w
		btfsc	STATUS,c
		goto	display
		movf	state2,w
		andlw	H'0F'
		subwf	pointer,w
		btfss	STATUS,z
		goto	different_key
		btfss	PORTA,3
		goto	no_key
exit_of_keys	bcf	state,key_in
		goto	display
no_key		bcf	state,key_in
		movlw	H'F0'
		andwf	state2,f
		goto	display
different_key	btfss	PORTA,3
		goto	exit_of_keys
		bsf	state,key_in
		movlw	H'F0'
		andwf	state2,f
		movf	pointer,w
		iorwf	state2,f		
display		decfsz	pointer,f
		goto	to_ports
		bsf	pointer,3
to_ports	clrf	PORTB
		btfss	state2,a1_switch_on
		goto	a2_yet
		movlw	H'06'
		subwf	pointer,w
		btfss	STATUS,z
		goto	a2_yet
		goto	with_alarm
a2_yet		btfss	state2,a2_switch_on
		goto	no_alarm
		movlw	H'07'
		subwf	pointer,w
		btfss	STATUS,z
		goto	no_alarm
with_alarm	bsf	STATUS,RP0
		bcf	TRISA,3
		bcf	STATUS,RP0
		decf	pointer,w
		iorlw	H'08'
		goto	to_PORTA
no_alarm	decf	pointer,w
to_PORTA	movwf	PORTA
		movlw	H'06'
		subwf	pointer,w
		btfsc	STATUS,c
		goto	data_to_PORTB
		bsf	STATUS,RP0
		bsf	TRISA,3
		bcf	STATUS,RP0
data_to_PORTB	bsf	PCLATH,0
		movf	pointer,w
		addwf	PCL,f
		nop
		goto	digit_1
		goto	digit_2
		goto	digit_3
		goto	digit_4
		goto	digit_5
		goto	digit_6
		goto	digit_7
; ********************* Cislo 8 ******************
		btfsc	state,key_in
		call	next_data
		btfss	what_display,time_fl
		goto	digit_8_a1_on
		swapf	hour,w
		goto	without_zero
digit_8_a1_on	btfss	what_display,a1_on
		goto	digit_8_a2_on
		movlw	b'11011110'
		goto	only_display
digit_8_a2_on	btfss	what_display,a2_on
		goto	digit_8_a2_off
		movlw	b'11011110'
		goto	only_display
digit_8_a2_off	btfss	what_display,a2_off
		goto	digit_8_a2_days
		movlw	b'11011110'
		goto	only_display
digit_8_a2_days	btfss	what_display,a2_days
		goto	digit_8_date
		movlw	b'11011110'
		goto	only_display
digit_8_date	movf	day_name,w
		bsf	PCLATH,1
		call	decode_day_1
		goto	only_display
; ********************* Cislo 7 *****************
digit_7		btfss	what_display,time_fl
		goto	digit_7_a1_on
		btfsc	state2,a1_validity
		bsf	state,dec_point
		movf	hour,w
		goto	end_of_display
digit_7_a1_on	btfss	what_display,a1_on
		goto	digit_7_a2_on
		movlw	b'00011000'
		goto	only_display
digit_7_a2_on	btfss	what_display,a2_on
		goto	digit_7_a2_off
		movlw	b'01101110'
		goto	only_display
digit_7_a2_off	btfss	what_display,a2_off
		goto	digit_7_a2_days
		movlw	b'01101110'
		goto	only_display
digit_7_a2_days	btfss	what_display,a2_days
		goto	digit_7_date
		movlw	b'01101110'
		goto	only_display
digit_7_date	movf	day_name,w
		bsf	PCLATH,1
		call	decode_day_2
		goto	only_display
; ********************* Cislo 6 *******************
digit_6		btfss	what_display,time_fl
		goto	digit_6_a1_on
		movlw	b'00000010'
		btfsc	state,control_ok
		goto	only_display
		goto	no_sign
digit_6_a1_on	btfss	what_display,a1_on
		goto	digit_6_a2_on
		btfss	state2,a1_validity
		goto	no_sign
		movlw	b'00000010'
		goto	only_display
digit_6_a2_on	btfss	what_display,a2_on
		goto	digit_6_a2_off
		btfss	state2,a2_validity
		goto	no_sign
		movlw	b'00000010'
		goto	only_display
digit_6_a2_off	btfss	what_display,a2_off
		goto	digit_6_a2_days
		movlw	b'01110010'
		goto	only_display
digit_6_a2_days	btfss	what_display,a2_days
		goto	digit_6_date
		goto	no_sign
digit_6_date	swapf	month,w
		andlw	H'0F'
		btfsc	STATUS,z
		goto	no_sign
digit_day_hi	swapf	day,w
		goto	without_zero
; ******************* Cislo 5 *******************
digit_5		btfss	what_display,time_fl
		goto	digit_5_a1_on
		swapf	min,w
		goto	end_of_display
digit_5_a1_on	btfss	what_display,a1_on
		goto	digit_5_a2_on
		swapf	a1_hour_on,w
		goto	without_zero
digit_5_a2_on	btfss	what_display,a2_on
		goto	digit_5_a2_off
		swapf	a2_hour_on,w
		goto	without_zero
digit_5_a2_off	btfss	what_display,a2_off
		goto	digit_5_a2_days
		swapf	a2_hour_off,w
without_zero	andlw	H'0F'
		btfsc	STATUS,z
		goto	no_sign
		goto	cont_zero		
digit_5_a2_days	btfss	what_display,a2_days
		goto	digit_5_date
		swapf	a2_days_on,w
		andlw	H'0F'
		bsf	PCLATH,1
		call	decode_day_1
		goto	only_display
digit_5_date	swapf	month,w
		andlw	H'0F'
		btfsc	STATUS,z
		goto	digit_day_hi
digit_day_lo	movf	day,w
		bsf	state,dec_point
		goto	end_of_display
; ******************** Cislo 4 *****************
digit_4		btfss	what_display,time_fl
		goto	digit_4_a1_on
		btfsc	state,key_in
		bcf	state2,a1_switch_on
		btfsc	state2,a2_validity
		bsf	state,dec_point
		movf	min,w
		goto	end_of_display
digit_4_a1_on	btfss	what_display,a1_on
		goto	digit_4_a2_on
		btfsc	state,key_in
		call	change_a1_val
		movf	a1_hour_on,w
		goto	end_of_display
digit_4_a2_on	btfss	what_display,a2_on
		goto	digit_4_a2_off
		btfsc	state,key_in
		call	change_a2_val
		movf	a2_hour_on,w
		goto	end_of_display
digit_4_a2_off	btfss	what_display,a2_off
		goto	digit_4_a2_days
		movf	a2_hour_off,w
		goto	end_of_display
digit_4_a2_days	btfss	what_display,a2_days
		goto	digit_4_date
		btfsc	state,key_in
		call	minus_day_hi
		swapf	a2_days_on,w
		andlw	H'0F'
		bsf	PCLATH,1
		call	decode_day_2
		goto	only_display
digit_4_date	swapf	month,w
		andlw	H'0F'
		btfsc	STATUS,z
		goto	digit_day_lo
		swapf	month,w
		goto	end_of_display
; ********************* Cislo 3 ********************
digit_3		btfss	what_display,time_fl
		goto	digit_3_a1_on
		btfsc	state,key_in
		bcf	state2,a2_switch_on
		goto	no_sign
digit_3_a1_on	btfss	what_display,a1_on
		goto	digit_3_a2_on
		btfss	state,key_in
		goto	label_a
		movf	a1_hour_on,w
		call	plus_hour
		movwf	a1_hour_on
		movlw	H'02'
		call	to_eeprom
label_a		movlw	b'00000010'
		goto	only_display
digit_3_a2_on	btfss	what_display,a2_on
		goto	digit_3_a2_off
		btfss	state,key_in
		goto	label_b
		movf	a2_hour_on,w
		call	plus_hour
		movwf	a2_hour_on
		movlw	H'04'
		call	to_eeprom
label_b		movlw	b'00000010'
		goto	only_display
digit_3_a2_off	btfss	what_display,a2_off
		goto	digit_3_a2_days
		btfss	state,key_in
		goto	label_c
		movf	a2_hour_off,w
		call	plus_hour
		movwf	a2_hour_off
		movlw	H'07'
		call	to_eeprom
label_c		movlw	b'00000010'
		goto	only_display
digit_3_a2_days	btfss	what_display,a2_days
		goto	digit_3_date
		btfsc	state,key_in
		call	plus_day_hi
		movlw	b'00000010'
		goto	only_display
digit_3_date	movf	month,w
		bsf	state,dec_point
		goto	end_of_display
; ********************* Cislo 2 *******************
digit_2		btfss	what_display,time_fl
		goto	digit_2_a1_on
		btfsc	state,key_in
		bsf	state2,a1_switch_on
		swapf	sec,w
		goto	end_of_display
digit_2_a1_on	btfss	what_display,a1_on
		goto	digit_2_a2_on
		btfss	state,key_in
		goto	label_d
		movf	a1_min_on,w
		call	plus_min_hi
		movwf	a1_min_on
		movlw	H'01'
		call	to_eeprom
label_d		swapf	a1_min_on,w
		goto	end_of_display
digit_2_a2_on	btfss	what_display,a2_on
		goto	digit_2_a2_off
		btfss	state,key_in
		goto	label_e
		movf	a2_min_on,w
		call	plus_min_hi
		movwf	a2_min_on
		movlw	H'03'
		call	to_eeprom
label_e		swapf	a2_min_on,w
		goto	end_of_display
digit_2_a2_off	btfss	what_display,a2_off
		goto	digit_2_a2_days
		btfss	state,key_in
		goto	label_f
		movf	a2_min_off,w
		call	plus_min_hi
		movwf	a2_min_off
		movlw	H'06'
		call	to_eeprom
label_f		swapf	a2_min_off,w
		goto	end_of_display
digit_2_a2_days	btfss	what_display,a2_days
		goto	digit_2_date
		btfsc	state,key_in
		call	minus_day_lo
		movf	a2_days_on,w
		andlw	H'0F'
		bsf	PCLATH,1
		call	decode_day_1
		goto	only_display
digit_2_date	swapf	year,w
		goto	end_of_display
; ********************* Cislo 1 *******************
digit_1		btfss	what_display,time_fl
		goto	digit_1_a1_on
		btfsc	state,key_in
		bsf	state2,a2_switch_on
		movf	sec,w
		goto	end_of_display
digit_1_a1_on	btfss	what_display,a1_on
		goto	digit_1_a2_on
		btfss	state,key_in
		goto	label_g
		movf	a1_min_on,w
		call	plus_min_lo
		movwf	a1_min_on
		movlw	H'01'
		call	to_eeprom
label_g		movf	a1_min_on,w
		goto	end_of_display
digit_1_a2_on	btfss	what_display,a2_on
		goto	digit_1_a2_off
		btfss	state,key_in
		goto	label_h
		movf	a2_min_on,w
		call	plus_min_lo
		movwf	a2_min_on
		movlw	H'03'
		call	to_eeprom
label_h		movf	a2_min_on,w
		goto	end_of_display
digit_1_a2_off	btfss	what_display,a2_off
		goto	digit_1_a2_days
		btfss	state,key_in
		goto	label_i
		movf	a2_min_off,w
		call	plus_min_lo
		movwf	a2_min_off
		movlw	H'06'
		call	to_eeprom
label_i		movf	a2_min_off,w
		goto	end_of_display
digit_1_a2_days	btfss	what_display,a2_days
		goto	digit_1_date
		btfsc	state,key_in
		call	plus_day_lo
		movf	a2_days_on,w
		andlw	H'0F'
		bsf	PCLATH,1
		call	decode_day_2
		goto	only_display
digit_1_date	movf	year,w
end_of_display	andlw	H'0F'
cont_zero	bsf	PCLATH,1
		call	table_of_signs
only_display	btfsc	state,dec_point
		iorlw	H'01'
		bcf	state,dec_point
		movwf	PORTB
no_sign		clrf	PCLATH
		retfie
; *************************************************************
; *** Zrotuje bity v registru what_display, pohlida hodnotu ***
; *** tohoto registru					    ***
; *************************************************************
next_data	rlf	what_display,f
		btfss	what_display,6
		return
		clrf	what_display
		bsf	what_display,0
		return
; ************************************************
; *** Podpurne programy pro reakci na tlacitka ***
; ************************************************
change_a1_val	btfss	state2,a1_validity
		goto	end_a1_change
		bcf	state2,a1_validity
		goto	end_of_val_ch
end_a1_change	bsf	state2,a1_validity
		goto	end_of_val_ch
change_a2_val	btfss	state2,a2_validity
		goto	end_a2_change
		bcf	state2,a2_validity
		goto	end_of_val_ch
end_a2_change	bsf	state2,a2_validity
end_of_val_ch	movf	state2,w
		andlw	H'50'
		movwf	EEDATA
		movlw	H'08'
		call	to_eeprom
		return
plus_hour	movwf	temp
		incf	temp,f
		movf	temp,w
		sublw	H'23'
		btfss	STATUS,c
		clrf	temp
		movf	temp,w
		andlw	H'0F'
		sublw	H'09'
		movf	temp,w
		btfsc	STATUS,c
		goto	eoh
		andlw	H'F0'
		addlw	H'10'
eoh		movwf	EEDATA
		return
plus_min_hi	movwf	temp
		movlw	H'10'
		addwf	temp,f
		movf	temp,w
		andlw	H'F0'
		sublw	H'50'
		movf	temp,w
		btfsc	STATUS,c
		goto	eomh
		andlw	H'0F'
eomh		movwf	EEDATA
		return
plus_min_lo	movwf	temp
		incf	temp,f
		movf	temp,w
		andlw	H'0F'
		sublw	H'09'
		movf	temp,w
		btfsc	STATUS,c
		goto	eoml
		andlw	H'F0'
eoml		movwf	EEDATA		
		return
plus_day_hi	movlw	H'10'
		addwf	a2_days_on,f
		btfss	a2_days_on,7
		goto	eod
		bcf	a2_days_on,7
		bsf	a2_days_on,4
		goto	eod
plus_day_lo	incf	a2_days_on,f
		btfss	a2_days_on,3
		goto	eod
		bcf	a2_days_on,3
		bsf	a2_days_on,0
		goto	eod
minus_day_hi	movlw	H'10'
		subwf	a2_days_on,f
		swapf	a2_days_on,w
		andlw	H'0F'
		btfss	STATUS,z
		goto	eod
		movlw	H'70'
		iorwf	a2_days_on,f
		goto	eod
minus_day_lo	decf	a2_days_on,f
		movf	a2_days_on,w
		andlw	H'0F'
		btfss	STATUS,z
		goto	eod
		movlw	H'07'
		iorwf	a2_days_on,f
eod		swapf	a2_days_on,w
		subwf	a2_days_on,w
		btfss	STATUS,c
		goto	eod_continue
		movlw	H'F0'
		andwf	a2_days_on,f
		swapf	a2_days_on,w
		iorwf	a2_days_on,f		
eod_continue	movf	a2_days_on,w
		movwf	EEDATA
		movlw	H'05'
to_eeprom	movwf	EEADR
		bsf	STATUS,RP0
		bsf	EECON1,WREN
		movlw	H'55'
		movwf	EECON2
		movlw	H'AA'
		movwf	EECON2
		bsf	EECON1,wr
		bcf	STATUS,RP0
		return
; *************************************************************
; *** Zde zacina program, probehne reset udaju pri spusteni ***
; *************************************************************
start		clrf	INDF
		incf	FSR,f
		movf	FSR,w
		xorlw	H'30'
		btfss	STATUS,z
		goto	start
		bsf	state,signal_error
		bsf	pointer,3
loop_a		movf	pointer,w
		movwf	EEADR
		bsf	STATUS,RP0
		bsf	EECON1,rd
		bcf	STATUS,RP0
		addlw	H'27'
		movwf	FSR
		movf	EEDATA,w
		movwf	INDF
		decfsz	pointer,f
		goto	loop_a
		bsf	pointer,3
		bsf	what_display,0
		bsf	STATUS,RP0
		movlw	H'C1'
		movwf	OPTION_REG
		movlw	H'18'
		movwf	TRISA
		clrf	TRISB
		bcf	STATUS,RP0
		bsf	INTCON,T0IE
		bsf	INTCON,GIE
; *********************************************
; *** Zde program ceka na preruseni od TMR0 ***
; *********************************************
begin		goto	begin
;
;
;
; ***********************************************************
; *** Zde zacinaji tabulky umistene do 3 pametove oblasti ***
; ***********************************************************
		org	H'03B0'
; ***********************************************
; *** Tabulka poctu dnu pro jednotlive mesice ***
; ***********************************************
table_of_days	addwf	PCL,f
		retlw	H'00'
		retlw	H'32'
		retlw	H'29'
		retlw	H'32'
		retlw	H'31'
		retlw	H'32'
		retlw	H'31'
		retlw	H'32'
		retlw	H'32'
		retlw	H'31'
; ******************************************************
; *** Tabulka polohy bitu dcf_bit v casove informaci ***
; ******************************************************
table_dcf_code	addwf	PCL,f
		retlw	H'00'
		retlw	H'20'
		retlw	H'40'
		retlw	H'60'
		retlw	H'80'
		retlw	H'A0'
		retlw	H'C0'
		retlw	H'08'
		retlw	H'01'
		retlw	H'21'
		retlw	H'41'
		retlw	H'61'
		retlw	H'81'
		retlw	H'A1'
		retlw	H'08'
		retlw	H'02'
		retlw	H'22'
		retlw	H'42'
		retlw	H'62'
		retlw	H'82'
		retlw	H'A2'
		retlw	H'03'
		retlw	H'23'
		retlw	H'43'
		retlw	H'04'
		retlw	H'24'
		retlw	H'44'
		retlw	H'64'
		retlw	H'84'
		retlw	H'05'
		retlw	H'25'
		retlw	H'45'
		retlw	H'65'
		retlw	H'85'
		retlw	H'A5'
		retlw	H'C5'
		retlw	H'E5'
		retlw	H'08'
; ***************************************************************
; *** Tabulka kodu znaku pro jednotlive segmenty LED displaye ***
; ***************************************************************
table_of_signs	addwf	PCL,f
		retlw	B'11111100'	; 0
		retlw	B'00011000'	; 1
		retlw	B'01101110'	; 2
		retlw	B'00111110'	; 3
		retlw	B'10011010'	; 4
		retlw	B'10110110'	; 5
		retlw	B'11110110'	; 6
		retlw	B'10011100'	; 7
		retlw	B'11111110'	; 8
		retlw	B'10111110'	; 9
; *********************************
; *** Tabulka prvniho znaku dne ***
; *********************************
decode_day_1	addwf	PCL,f
		retlw	b'11100110'	; E
		retlw	b'11001110'	; P
		retlw	b'11111000'	; U
		retlw	b'10110110'	; S
		retlw	b'11100100'	; C
		retlw	b'11001110'	; P
		retlw	b'10110110'	; S
		retlw	b'01010010'	; n
; *********************************
; *** Tabulka druheho znaku dne ***
; *********************************
decode_day_2	addwf	PCL,f
		retlw	b'11100111'	; E
		retlw	b'01110011'	; o
		retlw	b'11100011'	; t
		retlw	b'11100011'	; t
		retlw	b'11100011'	; t
		retlw	b'11011111'	; A
		retlw	b'01110011'	; o
		retlw	b'11100111'	; E
; *********************************
; *** Definition Of EEPROM Data ***
; *********************************
		Org	H'2100'
		DATA	H'FF',H'30',H'08',H'00',H'09',H'15',H'30',H'09'	; NC,A1-m,A1-h,A2-m,A2-h,A2-d,A2-m,A2-h
		DATA	H'00'						; STAV alarmu